diff --git a/gdb/testsuite/gdb.go/basic-types.exp b/gdb/testsuite/gdb.go/basic-types.exp
index c1009f93e86..ce56ba4a681 100644
--- a/gdb/testsuite/gdb.go/basic-types.exp
+++ b/gdb/testsuite/gdb.go/basic-types.exp
@@ -20,7 +20,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests
+require allow_go_tests
 
 proc test_integer_literal_types_accepted {} {
     # Test various decimal values.
diff --git a/gdb/testsuite/gdb.go/chan.exp b/gdb/testsuite/gdb.go/chan.exp
index 075d9f81908..fcb45cb9ab5 100644
--- a/gdb/testsuite/gdb.go/chan.exp
+++ b/gdb/testsuite/gdb.go/chan.exp
@@ -20,7 +20,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/global-local-var-shadow.exp b/gdb/testsuite/gdb.go/global-local-var-shadow.exp
index 8513c5530a5..be3e23ed29b 100644
--- a/gdb/testsuite/gdb.go/global-local-var-shadow.exp
+++ b/gdb/testsuite/gdb.go/global-local-var-shadow.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/handcall.exp b/gdb/testsuite/gdb.go/handcall.exp
index 530bddff140..9eb6077a056 100644
--- a/gdb/testsuite/gdb.go/handcall.exp
+++ b/gdb/testsuite/gdb.go/handcall.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/hello.exp b/gdb/testsuite/gdb.go/hello.exp
index 5f7da349fe5..494d2b9d843 100644
--- a/gdb/testsuite/gdb.go/hello.exp
+++ b/gdb/testsuite/gdb.go/hello.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/integers.exp b/gdb/testsuite/gdb.go/integers.exp
index 7c06d0584ed..e9413d047f7 100644
--- a/gdb/testsuite/gdb.go/integers.exp
+++ b/gdb/testsuite/gdb.go/integers.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/max-depth.exp b/gdb/testsuite/gdb.go/max-depth.exp
index 8fa967c5d29..17f4f450d49 100644
--- a/gdb/testsuite/gdb.go/max-depth.exp
+++ b/gdb/testsuite/gdb.go/max-depth.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/methods.exp b/gdb/testsuite/gdb.go/methods.exp
index f641c1cf0db..bd7a2e99b59 100644
--- a/gdb/testsuite/gdb.go/methods.exp
+++ b/gdb/testsuite/gdb.go/methods.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/package.exp b/gdb/testsuite/gdb.go/package.exp
index 8c64d2c7d86..33e7de65c11 100644
--- a/gdb/testsuite/gdb.go/package.exp
+++ b/gdb/testsuite/gdb.go/package.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile package1.go package2.go
 
diff --git a/gdb/testsuite/gdb.go/print.exp b/gdb/testsuite/gdb.go/print.exp
index 0c1f0eda98f..893fa30e7be 100644
--- a/gdb/testsuite/gdb.go/print.exp
+++ b/gdb/testsuite/gdb.go/print.exp
@@ -20,7 +20,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests
+require allow_go_tests
 
 proc test_float_accepted {} {
     global gdb_prompt
diff --git a/gdb/testsuite/gdb.go/strings.exp b/gdb/testsuite/gdb.go/strings.exp
index 1bca7146db4..6e98eaab619 100644
--- a/gdb/testsuite/gdb.go/strings.exp
+++ b/gdb/testsuite/gdb.go/strings.exp
@@ -17,7 +17,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/types.exp b/gdb/testsuite/gdb.go/types.exp
index 22656f2174d..5aa93acfdfd 100644
--- a/gdb/testsuite/gdb.go/types.exp
+++ b/gdb/testsuite/gdb.go/types.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/unsafe.exp b/gdb/testsuite/gdb.go/unsafe.exp
index 5a2bf32fcf5..3957814f2fb 100644
--- a/gdb/testsuite/gdb.go/unsafe.exp
+++ b/gdb/testsuite/gdb.go/unsafe.exp
@@ -19,7 +19,7 @@
 
 load_lib "go.exp"
 
-require !skip_go_tests support_go_compile
+require allow_go_tests support_go_compile
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/lib/gdb.exp b/gdb/testsuite/lib/gdb.exp
index 6985f721515..f3f0bfac762 100644
--- a/gdb/testsuite/lib/gdb.exp
+++ b/gdb/testsuite/lib/gdb.exp
@@ -2415,10 +2415,10 @@ proc allow_ada_tests {} {
     return 1
 }
 
-# Return a 1 if I don't even want to try to test GO.
+# Return a 1 if I want to try to test GO.
 
-proc skip_go_tests {} {
-    return 0
+proc allow_go_tests {} {
+    return 1
 }
 
 # Return a 1 if I even want to try to test D.
diff --git a/gdb/testsuite/lib/go.exp b/gdb/testsuite/lib/go.exp
index 21d71ce06df..5b694bda096 100644
--- a/gdb/testsuite/lib/go.exp
+++ b/gdb/testsuite/lib/go.exp
@@ -13,7 +13,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-# FIXME: Presumably skip_go_tests should be defined here,
+# FIXME: Presumably allow_go_tests should be defined here,
 # but for consistency with other languages it currently lives in gdb.exp.
 
 # Auxiliary function to set the language to Go.