diff --git a/gdb/testsuite/gdb.perf/backtrace.exp b/gdb/testsuite/gdb.perf/backtrace.exp
index d8b046b5cd1..38cdd5da0a8 100644
--- a/gdb/testsuite/gdb.perf/backtrace.exp
+++ b/gdb/testsuite/gdb.perf/backtrace.exp
@@ -21,7 +21,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .c
 set executable $testfile
diff --git a/gdb/testsuite/gdb.perf/disassemble.exp b/gdb/testsuite/gdb.perf/disassemble.exp
index ee33dcf0481..067754747ec 100644
--- a/gdb/testsuite/gdb.perf/disassemble.exp
+++ b/gdb/testsuite/gdb.perf/disassemble.exp
@@ -17,7 +17,7 @@
 # some large functions in GDB.
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 global GDB
 
diff --git a/gdb/testsuite/gdb.perf/gmonster1-null-lookup.exp b/gdb/testsuite/gdb.perf/gmonster1-null-lookup.exp
index 1c17cd7f450..706ea7a87d4 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-null-lookup.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-null-lookup.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-null-lookup.py NullLookup
diff --git a/gdb/testsuite/gdb.perf/gmonster1-pervasive-typedef.exp b/gdb/testsuite/gdb.perf/gmonster1-pervasive-typedef.exp
index ae175f3a1ef..b3b992a6872 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-pervasive-typedef.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-pervasive-typedef.exp
@@ -21,6 +21,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-pervasive-typedef.py PervasiveTypedef
diff --git a/gdb/testsuite/gdb.perf/gmonster1-print-cerr.exp b/gdb/testsuite/gdb.perf/gmonster1-print-cerr.exp
index 54f7f00b42b..a0827339025 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-print-cerr.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-print-cerr.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-print-cerr.py PrintCerr
diff --git a/gdb/testsuite/gdb.perf/gmonster1-ptype-string.exp b/gdb/testsuite/gdb.perf/gmonster1-ptype-string.exp
index f37cead361f..426c968995c 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-ptype-string.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-ptype-string.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-ptype-string.py GmonsterPtypeString
diff --git a/gdb/testsuite/gdb.perf/gmonster1-runto-main.exp b/gdb/testsuite/gdb.perf/gmonster1-runto-main.exp
index 8b4311ed43d..ad235dbe897 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-runto-main.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-runto-main.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-runto-main.py GmonsterRuntoMain
diff --git a/gdb/testsuite/gdb.perf/gmonster1-select-file.exp b/gdb/testsuite/gdb.perf/gmonster1-select-file.exp
index 71b3d61b772..1e720acf147 100644
--- a/gdb/testsuite/gdb.perf/gmonster1-select-file.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1-select-file.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster1.exp make_testcase_config gmonster-select-file.py GmonsterSelectFile
diff --git a/gdb/testsuite/gdb.perf/gmonster1.exp b/gdb/testsuite/gdb.perf/gmonster1.exp
index 900452501eb..7ccf9fa9b53 100644
--- a/gdb/testsuite/gdb.perf/gmonster1.exp
+++ b/gdb/testsuite/gdb.perf/gmonster1.exp
@@ -36,7 +36,7 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 if ![info exists MONSTER] {
     set MONSTER "n"
diff --git a/gdb/testsuite/gdb.perf/gmonster2-null-lookup.exp b/gdb/testsuite/gdb.perf/gmonster2-null-lookup.exp
index 353e6f12202..f98c5a5a658 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-null-lookup.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-null-lookup.exp
@@ -20,6 +20,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-null-lookup.py NullLookup
diff --git a/gdb/testsuite/gdb.perf/gmonster2-pervasive-typedef.exp b/gdb/testsuite/gdb.perf/gmonster2-pervasive-typedef.exp
index e37c1a4b2f6..ce3d48b8ba8 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-pervasive-typedef.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-pervasive-typedef.exp
@@ -21,6 +21,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-pervasive-typedef.py PervasiveTypedef
diff --git a/gdb/testsuite/gdb.perf/gmonster2-print-cerr.exp b/gdb/testsuite/gdb.perf/gmonster2-print-cerr.exp
index ccb9e733fb4..2020ddffdbe 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-print-cerr.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-print-cerr.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-print-cerr.py PrintCerr
diff --git a/gdb/testsuite/gdb.perf/gmonster2-ptype-string.exp b/gdb/testsuite/gdb.perf/gmonster2-ptype-string.exp
index a21fa349b7a..c153b2f2c19 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-ptype-string.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-ptype-string.exp
@@ -20,6 +20,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-ptype-string.py GmonsterPtypeString
diff --git a/gdb/testsuite/gdb.perf/gmonster2-runto-main.exp b/gdb/testsuite/gdb.perf/gmonster2-runto-main.exp
index 05e2ec37dca..b1cbfe1de0f 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-runto-main.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-runto-main.exp
@@ -19,6 +19,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-runto-main.py GmonsterRuntoMain
diff --git a/gdb/testsuite/gdb.perf/gmonster2-select-file.exp b/gdb/testsuite/gdb.perf/gmonster2-select-file.exp
index 869f048e091..aa0428cfe4b 100644
--- a/gdb/testsuite/gdb.perf/gmonster2-select-file.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2-select-file.exp
@@ -20,6 +20,6 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 GenPerfTest::standard_run_driver gmonster2.exp make_testcase_config gmonster-select-file.py GmonsterSelectFile
diff --git a/gdb/testsuite/gdb.perf/gmonster2.exp b/gdb/testsuite/gdb.perf/gmonster2.exp
index bb0b76994b9..b1f1c5f642d 100644
--- a/gdb/testsuite/gdb.perf/gmonster2.exp
+++ b/gdb/testsuite/gdb.perf/gmonster2.exp
@@ -36,7 +36,7 @@
 load_lib perftest.exp
 load_lib gen-perf-test.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 if ![info exists MONSTER] {
     set MONSTER "n"
diff --git a/gdb/testsuite/gdb.perf/single-step.exp b/gdb/testsuite/gdb.perf/single-step.exp
index b46f838ea8c..4638c55e68b 100644
--- a/gdb/testsuite/gdb.perf/single-step.exp
+++ b/gdb/testsuite/gdb.perf/single-step.exp
@@ -19,7 +19,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .c
 set executable $testfile
diff --git a/gdb/testsuite/gdb.perf/skip-command.exp b/gdb/testsuite/gdb.perf/skip-command.exp
index c0019331cac..0b691992861 100644
--- a/gdb/testsuite/gdb.perf/skip-command.exp
+++ b/gdb/testsuite/gdb.perf/skip-command.exp
@@ -25,7 +25,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .cc skip-funcs.cc
 set executable $testfile
diff --git a/gdb/testsuite/gdb.perf/skip-prologue.exp b/gdb/testsuite/gdb.perf/skip-prologue.exp
index aaa0bbfe6ff..4b246296741 100644
--- a/gdb/testsuite/gdb.perf/skip-prologue.exp
+++ b/gdb/testsuite/gdb.perf/skip-prologue.exp
@@ -21,7 +21,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .c
 set executable $testfile
diff --git a/gdb/testsuite/gdb.perf/solib.exp b/gdb/testsuite/gdb.perf/solib.exp
index 95d014090f8..7c37288c42a 100644
--- a/gdb/testsuite/gdb.perf/solib.exp
+++ b/gdb/testsuite/gdb.perf/solib.exp
@@ -24,7 +24,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .c
 set executable $testfile
diff --git a/gdb/testsuite/gdb.perf/template-breakpoints.exp b/gdb/testsuite/gdb.perf/template-breakpoints.exp
index fae5c24681c..b737f3a888e 100644
--- a/gdb/testsuite/gdb.perf/template-breakpoints.exp
+++ b/gdb/testsuite/gdb.perf/template-breakpoints.exp
@@ -21,7 +21,7 @@
 
 load_lib perftest.exp
 
-require !skip_perf_tests
+require allow_perf_tests
 
 standard_testfile .cc
 set executable $testfile
diff --git a/gdb/testsuite/lib/perftest.exp b/gdb/testsuite/lib/perftest.exp
index 7ecd79651ed..14dd057ed54 100644
--- a/gdb/testsuite/lib/perftest.exp
+++ b/gdb/testsuite/lib/perftest.exp
@@ -129,9 +129,9 @@ namespace eval PerfTest {
     }
 }
 
-# Return true if performance tests are skipped.
+# Return true if performance tests are to be run.
 
-proc skip_perf_tests { } {
+proc allow_perf_tests { } {
     global GDB_PERFTEST_MODE
 
     if [info exists GDB_PERFTEST_MODE] {
@@ -139,13 +139,13 @@ proc skip_perf_tests { } {
 	     && "$GDB_PERFTEST_MODE" != "run"
 	     && "$GDB_PERFTEST_MODE" != "both" } {
 	    error "Unknown value of GDB_PERFTEST_MODE."
-	    return 1
+	    return 0
 	}
 
-	return 0
+	return 1
     }
 
-    return 1
+    return 0
 }
 
 # Given a list of tcl strings, return the same list as the text form of a